<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>contact detail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container">
        <p class="h3 text-center mt-5">THÔNG TIN LIÊN HỆ CHI TIẾT</p>
        <br>
        <br>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Name(*)</label>
            </div>
            <div class="col-8">
                <input class="form-control" id="inp-name">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Email(*)</label>
            </div>
            <div class="col-8">
                <input class="form-control" id="inp-email">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Message(*)</label>
            </div>
            <div class="col-8">
                <textarea class="form-control" id="inp-message" rows="3"></textarea>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label>Ngày liên hệ(*)</label>
            </div>
            <div class="col-8">
                <input class="form-control" id="inp-date">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">

            </div>
            <div class="col-8">
                <button onclick="onBtnSaveData()" class="btn btn-group btn-success" id="btn-sava-data" type="submit">Save
                    data</button>
            </div>
        </div>
    </div>
</body>

</html>
<script>
    "use strict";

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC ***/
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện ***/
    // Hàm thực hiện khi load trang
    function onPageLoading() {
        // Lấy Id từ querystring
        const urlParams = new URLSearchParams(window.location.search);
        const contactId = urlParams.get('id');
        if (contactId) {
            // Gọi API để lấy thông tin contact dựa trên Id
            getContactDetail(contactId);
        }
    }

    // Hàm thực hiện khi click button Save Data
    function onBtnSaveData() {
        // Bước 1: Thu thập dữ liệu
        const name = document.getElementById('inp-name').value;
        const email = document.getElementById('inp-email').value;
        const message = document.getElementById('inp-message').value;
        const date = document.getElementById('inp-date').value;

        // Bước 2: Validate dữ liệu
        if (!name || !email || !message || !date) {
            alert('Vui lòng nhập đầy đủ thông tin!');
            return;
        }

        if (!validateEmail(email)) {
            alert('Email không hợp lệ!');
            return;
        }

        if (message.length < 20) {
            alert('Message phải có độ dài trên 20 ký tự!');
            return;
        }

        // Bước 3: Gọi API để sửa thông tin liên hệ
        const contactId = getContactIdFromQueryString();
        if (contactId) {
            const contactData = {
                name: name,
                email: email,
                message: message,
                date: date,
            };
            updateContact(contactId, contactData);
        }
    }

    /*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình***/
    // Hàm kiểm tra email hợp lệ
    function validateEmail(email) {
        const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        return emailRegex.test(email);
    }

    // Hàm lấy Id từ querystring
    function getContactIdFromQueryString() {
        const urlParams = new URLSearchParams(window.location.search);
        return urlParams.get('id');
    }

    // Hàm gọi API để lấy thông tin contact dựa trên Id
    function getContactDetail(contactId) {
        const apiUrl = gBASE_URL + 'contacts/' + contactId;
        const xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function () {
            if (xhr.readyState === XMLHttpRequest.DONE) {
                if (xhr.status === gREQUEST_STATUS_OK) {
                    const response = JSON.parse(xhr.responseText);
                    // Hiển thị thông tin contact lên form detail
                    document.getElementById('inp-name').value = response.name;
                    document.getElementById('inp-email').value = response.email;
                    document.getElementById('inp-message').value = response.message;
                    document.getElementById('inp-date').value = response.createDate;
                } else {
                    alert('Có lỗi xảy ra khi lấy thông tin contact!');
                }
            }
        };
        xhr.open('GET', apiUrl, true);
        xhr.send();
    }
    // Hàm gọi API để cập nhật thông tin contact
    function updateContact(contactId, contactData) {
        const apiUrl = gBASE_URL + 'contacts/' + contactId;
        const xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function () {
            if (xhr.readyState === XMLHttpRequest.DONE) {
                if (xhr.status === gREQUEST_STATUS_OK) {
                    alert('Sửa thông tin liên hệ thành công!');
                    // Chuyển lại về trang danh sách (listContact)
                    window.location.href = 'listContact.html';
                } else {
                    alert('Có lỗi xảy ra khi sửa thông tin liên hệ!');
                }
            }
        };
        xhr.open('PUT', apiUrl, true);
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.send(JSON.stringify(contactData));
    }


</script>